const path = require('path')
const rra = require('recursive-readdir-async')
const dir = path.resolve(_flitter.directories.middleware)

exports.up = async (ctx) => {
    const flap = ctx.flap
    const files = await rra.list(dir)
    
    for ( let key in files ) {
        const file = files[key].fullname
        if ( file.endsWith('.middleware.js') ){
            await flap.insert_line(file, /(?:\s^\n)*class\s+(?:[a-zA-Z0-9_])+(?:\n|\s)*/, 
                'const Middleware = require(\'libflitter/middleware/Middleware\')', true) // insert before
            await flap.find_replace_file(file, /(?:\s^\n)*class\s+(?:[a-zA-Z0-9_])+(?:\n|\s)*/, '%orig extends Middleware ')
        }
    }
}

exports.down = async (ctx) => {
    const flap = ctx.flap
    const files = await rra.list(dir)
    
    for ( let key in files ) {
        const file = files[key].fullname
        if ( file.endsWith('.middleware.js') ){
            await flap.delete_line(file, /const\s+Middleware\s+=\s+require\('libflitter\/middleware\/Middleware'\)/)
            await flap.find_replace_file(file, /(?:\s^\n)*class\s+(?:[a-zA-Z0-9_])+(?:\n|\s)+extends\s+Middleware/, '%orig', (m) => {
                return m.replace(/extends\s+Middleware/, '')
            })
        }
    }
}
